#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MIN_N = 1;
const int MAX_N = 300;
const int MIN_NI = 0;
const int MAX_NI = 100;

const int rnd_test_n = 100;

template <typename T> void append(vector<T> &dest, const vector<T> &orig) {
	dest.insert(dest.end(), orig.begin(), orig.end());
}

string output_tc(int n, const vector<int>& nums) {
	ostringstream oss;
    oss << n << endl;
    for (int i = 0; i < nums.size(); i++) {
        if (i != 0) oss << " ";
        oss << nums[i];
    }
    oss << endl;
	return oss.str();
}

vector<string> generate_sample_tests() {
	vector<string> tests;
    tests.push_back(output_tc(4, {3, 1, 5, 8}));
    tests.push_back(output_tc(2, {1, 5}));
	return tests;
}

vector<string> generate_manual_tests() {
	vector<string> tests;
	tests.push_back(output_tc(10, {1,1,1,1,1,1,1,1,1,0}));
	tests.push_back(output_tc(10, {0,0,0,0,0,0,0,0,0,0}));
	return tests;
}

string rnd_test(int i){
    int min_n = MIN_N;
    int max_n = MAX_N;
    
    if(i<rnd_test_n / 3){
        max_n = 5;
    }
    else if(i<rnd_test_n / 2){
        max_n = 20;
    }

    int x = rnd.next(min_n, max_n);
    vector<int> nums(x);
    for (int i = 0; i < x; i++) {
        nums[i] = rnd.next(MIN_NI, MAX_NI);
    }

    return(output_tc(x, nums));
}

vector<string> generate_random_tests() { 
    vector<string> tests;
    for (int i = 0; i < rnd_test_n; i++){
        tests.push_back(rnd_test(i));
    } 
    return tests;
}

string extreme_test_1(){
    vector<int> nums(300);
    for (int i = 0; i < 300; i++) {
        nums[i] = MAX_NI;
    }

    return(output_tc(MAX_N, nums));
}

string extreme_test_2(){
    vector<int> nums(300);
    for (int i = 0; i < 300; i++) {
        nums[i] = (i % 100) + 1;
    }

    return(output_tc(MAX_N, nums));
}

vector<string> generate_extreme_tests(){
    vector<string> tests;   
    tests.push_back(extreme_test_1());
    tests.push_back(extreme_test_2());
    return tests;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);
	vector<string> tests;
	size_t test = 0;
	append(tests, generate_sample_tests());
	append(tests, generate_manual_tests());
	append(tests, generate_random_tests());
	append(tests, generate_extreme_tests());
	for (const auto &t : tests) {
		startTest(++test);
		cout << t;
	}
	return 0;
}